/***************************************************************************/
/**                                                                       **/
/**              MODULAR-4 library for SPB module M-DA16-2                **/
/**                                                                       **/
/**  This file contains routines for Borland C++/3.1 to allow the user,   **/
/**  to write programs for the MODULAR-4 in "C" 			  **/
/**                                                                       **/
/**                             Version 2.E.                              **/
/**                                                                       **/
/**                    Last change : 28.11.1996                           **/
/**                    Adaptation to Windows 95, Windows NT and OS/2	  **/
/**                                                                       **/
/**                             Version 2.D.                              **/
/**                                                                       **/
/**  This file contains routines for Borland C++/3.1 to allow the user,   **/
/**  to write programs for the MODULAR-4 in "C" 			  **/
/**                                                                       **/
/**                    Last change : 07.07.1995 2.D.                      **/
/**                                                                       **/
/**             Changes between version 2.C. and 2.D.:                    **/
/**             - the module type check is now done with the low byte     **/
/**               of EEPROM-WORD 0 and not longer with the complete word  **/
/**                                                                       **/
/**                    Last change : 17.05.1995 2.C.                      **/
/**                                                                       **/
/**		  english, Windows DLLs for ML4 and ML5			  **/
/**                                                                       **/
/**                    Last change : 14.10.1994 2.B.                      **/
/**                                                                       **/
/**               ml8_read_eeprom changed to ml8_read_eeprom_copy 	  **/
/**                                                                       **/
/**                Date of release : 04.02.1994 2.A.                      **/
/**                    Last change : 04.02.1994                           **/
/**                         Author : H.K.                                 **/
/**                         Status : O.K.				  **/
/**                                                                       **/
/**                                                                       **/
/** This library was tested with Borland C++ Version 3.1.	          **/
/**                                                                       **/
/** No parameters are checked.						  **/
/**                                                                       **/
/**                                                                       **/
/**                                                                       **/
/**               (c) SORCUS Computer GmbH 1995                           **/
/**                                                                       **/
/***************************************************************************/

/* The switches for the library are set in the configuration files of Pascal
   (*.TP file) and C (project-file). They can also be set in this source file:

   Then the following #defines have to exist:

   If you use Pascal, #define BORLAND_PASCAL has to be included (default is C).

   If the library shall be used as realtime library on the MODULAR-4/486
   #define ML8 and #define ML8RT have to be included (default is PC library).

   If you work with Windows, this is detected by the compiler. No #defines have
   to be included.
*/

#include "m029_lib.h"


/* Static Arrays */

       STATIC short m029gain[ANZ_MOD] [2];
       STATIC short m029offset[ANZ_MOD] [2];
       STATIC short m029soll[ANZ_MOD] [2];
       STATIC short m029reset[ANZ_MOD] [2];

#if defined (__DLL__) && !defined (__OS2__)/* if a module DLL shall be generated */

#include <windows.h>

HANDLE   hInst;

#pragma argsused

int far pascal LibMain(hInstance, wDataSeg, wHeapSize, lpszCmdLine)
HANDLE  hInstance;                /* Instance of DLL          */
WORD    wDataSeg;                 /* Data segment             */
WORD    wHeapSize;                /* Size of heap 	      */
LPSTR   lpszCmdLine;              /* Pointer to command line  */

{

  hInst = hInstance;

  if (wHeapSize > 0) UnlockData(0);

  return(1);
}

#endif  /* __DLL__ */


/* Delay (multiples of 1 microsecond)
*/
void m029_delay(int m)
{
  int wait;
  for (wait=0;wait < m;wait++) {
    mlx_out_port(0x3F,0);        /* Delay min. 250 ns */
    mlx_out_port(0x3F,0);
    mlx_out_port(0x3F,0);
    mlx_out_port(0x3F,0);
  }
}
/* Correct output value with corgain and coroffset
*/
void correction(short corgain, short coroffset, short *data_var)
{
 short l1,ll1,hl1;

 /* Use the following formula:

    *data_var = (*data_var + coroffset) * (1 + corgain / 65536)        */

 if ((coroffset < 0) &&
    (*data_var < (-32767 - coroffset))) {    /* Lower limit check */
   l1 = -32767 -1;
 }
 else {
   if ((coroffset > 0) &&
      (*data_var > (32767 - coroffset))) {   /* Upper limit check */
     l1 = 32767;
   }
   else {
     l1 = *data_var + coroffset;             /* Assign value to a variable */
     }                                       /* and add offset (coroffset) */
  }
 ll1 = l1 % 256;                             /* Calculate low value */
 hl1 = l1 / 256;                             /* Calculate high value */
 ll1 = (ll1 * corgain) >> 16;                /* Low value * corgain div. 65536 */
 hl1 = (hl1 * corgain) >> 8;                 /* High value * corgain div. 256 */
 if (((ll1 + hl1) < 0) && (l1 < (-32767 - (ll1 + hl1)))) { /* Check lower limit */
   *data_var = -32767 -1;                    /* Return result */
 }
 else {
   if (((ll1 + hl1) > 0) && (l1 > (32767 - (ll1 + hl1)))) { /* Check upper limit */
     *data_var = 32767;                      /* Return result */
   }
   else {
     *data_var = l1 + ll1 + hl1;             /* Return result */
   }
 }
}

/* Correct Over-/Underflow of output value
*/
void overflow(short *data_var)
{

 if (*data_var < -32767) *data_var = -32767-1; /* Value < minimum : *data_var = mininum */
 if (*data_var > 32766) *data_var = 32767;     /* Value > maximum : *data_var = maxinum */
}

/* Init module library
*/
MLXAPI void EXPORT m029_bib_startup (void)
{
 ushort w;
 short m,endm;

  if (lobyte(mlx_read_eeprom(1,0)) == 0x29)    /* Check, whether module extender is used */
    endm = ANZ_MOD;                            /* Max. number of micro-slots */
  else
    endm = 5;                                  /* 4 micro-slots */
  for (m=1;m < endm;m++) {                     /* Check alle micro-slots */
    if (lobyte(mlx_read_eeprom(m,0)) == 0x1D) {      /* Correct module ? */
      w = mlx_read_eeprom(m,5);                /* Read gain and offset of channel 0 */
      m029gain[m] [0] = (char) (w >> 8);
      m029offset[m] [0] = (char) w;
      w = mlx_read_eeprom(m,3);                /* Start value after reset of channel 0 */
      m029reset[m] [0] = (short) w;
      w = mlx_read_eeprom(m,6);                /* Read gain and offset of channel 1 */
      m029soll[m] [0] = 0;
      m029gain[m] [1] = (char) (w >> 8);
      m029offset[m] [1] = (char) w;
      w = mlx_read_eeprom(m,4);                /* Start value after reset of channel 1 */
      m029reset[m] [1] = (short) w;
      m029soll[m] [1] = 0;
      }
      else {
      m029gain[m] [0] = 0;                     /* Gain channel 0 */
      m029offset[m] [0] = 0;                   /* Offset channel 0 */
      m029reset[m] [0] = 0;                    /* Start value channel */
      m029soll[m] [0] = 0;                     /* Set value of channel 0 */
      m029gain[m] [1] = 0;                     /* Gain channel 1 */
      m029offset[m] [1] = 0;                   /* Offset channel 1 */
      m029reset[m] [1] = 0;                    /* Start value channel 1 */
      m029soll[m] [1] = 0;                     /* Set value of channel 1 */
      }
    }
}

/* Define correction values
*/
MLXAPI void EXPORT m029_set_correct_values(byte micro_slot, byte channel, short corgain, short coroffset)
{
 m029gain[micro_slot] [channel] = corgain;           /* Correction for gain */
 m029offset[micro_slot] [channel] = coroffset;       /* Correction for offset */
}

/* Read correction value
*/
MLXAPI void EXPORT m029_get_correct_values(byte micro_slot, byte channel, short *corgain, short *coroffset)
{
 *corgain = m029gain[micro_slot] [channel];          /* Correction for gain */
 *coroffset = m029offset[micro_slot] [channel];      /* Correction for offset */
}

/* Correct output value
*/
MLXAPI void EXPORT m029_correct (byte micro_slot, byte channel, short *data_var)
{
  if ((m029gain[micro_slot] [channel] != 0)                        /* Correction values for gain and offset <> 0 ? */
    || (m029offset[micro_slot] [channel] != 0)) {
    correction(m029gain[micro_slot] [channel],                     /* Correct value */
      m029offset[micro_slot] [channel],data_var);
  }
  overflow(data_var);                                              /* Cut value, if necessary */
}

/* Output value to D/A-channel
*/
MLXAPI void EXPORT m029_out(byte micro_slot, byte channel, byte flag, short data_var)
{

  if (flag == 1)
    m029_correct(micro_slot,channel,&data_var);
  m029soll[micro_slot] [channel] = data_var;                                 /* Store set value */
  mlx_out_port(MBASIS+M029_POWER_DOWN0+(channel*4),0xff);                    /* Power-down */
  m029_delay(WAITTIME); 	       /* Wait min. 5 microseconds */
  mlx_out_port(MBASIS+M029_SET_DA0_HIGH+(channel*4),(char) (data_var >> 8)); /* Load D/A-converter (High byte) */
  m029_delay(WAITTIME);                /* Wait min. 5 microseconds */
  mlx_out_port(MBASIS+M029_POWER_DOWN0+(channel*4),0xff);                    /* Power-down */
  m029_delay(WAITTIME);                /* Wait min. 5 microseconds */
  mlx_out_port(MBASIS+M029_SET_DA0_LOW+(channel*4),(char) (data_var));       /* Load D/A-converter (Low byte) */
  m029_delay(WAITTIME);                /* Wait min. 5 microseconds */
  mlx_out_port(MBASIS+M029_POWER_DOWN0+(channel*4),0xff);                    /* Power-down */
  m029_delay(WAITTIME);                /* Wait min. 5 microseconds */
  }

/* Read set value of D/A-channel
*/
MLXAPI void EXPORT m029_get_setvalue(byte micro_slot, byte channel, short *datbyte)
{
  *datbyte = m029soll[micro_slot] [channel];
}

/* Init module line definitions in EEPROM
*/
MLXAPI void EXPORT m029_set_conf_eeprom(byte micro_slot)
{
  short data_var;

  m029_bib_startup();                                /* Load EEPROM values */
  data_var = m029reset[micro_slot] [0];              /* Load output value channel 0 */
  m029_correct(micro_slot,0,&data_var);              /* Correct and cut value, if necessary */
  m029_out(micro_slot,0,0,m029reset[micro_slot] [0]);  /* Output start value of channel 0 */
  data_var = m029reset[micro_slot] [1];              /* Load output value of channel 1 */
  m029_correct(micro_slot,0,&data_var);              /* Correct and cut value, if necessary */
  m029_out(micro_slot,1,0,m029reset[micro_slot] [1]);  /* Output start value of channel 1 */
}


