#ifndef _m029_lib_
#define _m029_lib_
/***************************************************************************/
/**                                                                       **/
/**              MODULAR-4 library for SPB module M-DA16-2                **/
/**                                                                       **/
/**                             Version 2.E.                              **/
/**                                                                       **/
/**                    Last change : 28.11.1996                           **/
/**                    Adaptation to Windows 95, Windows NT and OS/2	  **/
/**                                                                       **/
/**                             Version 2.D.                              **/
/**                                                                       **/
/**  This file contains routines for Borland C++/3.1 to allow the user,   **/
/**  to write programs for the MODULAR-4 in "C" 			  **/
/**                                                                       **/
/**                                                                       **/
/**                    Last change : 07.07.1995 2.D.                      **/
/**                                                                       **/
/**       Changes between version 2.C. and 2.D.:                          **/
/**       - changes only in C-source                                      **/
/**                                                                       **/
/**                    Last change : 17.05.1995 2.C.                      **/
/**                                                                       **/
/**                    Last change : 14.10.1994 2.B.                      **/
/**                                                                       **/
/**                Date of release : 04.02.1994 2.A.                      **/
/**                         Author : H.K.                                 **/
/**                         Status : O.K.                                 **/
/**                                                                       **/
/**                                                                       **/
/** Special comments: 							  **/
/**                                                                       **/
/** This library was tested with Borland C++ Version 3.1.	          **/
/**                                                                       **/
/** No parameters are checked.						  **/
/**                                                                       **/
/**                                                                       **/
/**                                                                       **/
/**               (c) SORCUS Computer GmbH 1995                           **/
/**                                                                       **/
/***************************************************************************/

/* The switches for the library are set in the configuration files of Pascal
   (*.TP file) and C (project-file). They can also be set in this source file:

   Then the following #defines have to exist:

   If you use Pascal, #define BORLAND_PASCAL has to be included (default is C).

   If the library shall be used as realtime library on the MODULAR-4/486
   #define ML8 and #define ML8RT have to be included (default is PC library).

   If you work with Windows, this is detected by the compiler. No #defines have
   to be included.
*/

#include <MODULE.H>

#define MBASIS            micro_slot_basis[micro_slot] /* Module base address */
#define M029_CLEAR        0x0                          /* CLEAR: Set both output values = 0      */
#define M029_SET_DA0_HIGH 0x1                          /* Load high byte channel DA-0            */
#define M029_SET_DA0_LOW  0x2                          /* Load low byte + output to channel DA-0 */
#define M029_POWER_DOWN0  0x3                          /* Power down                             */
#define M029_SET_DA1_HIGH 0x5                          /* Load high byte channel DA-1            */
#define M029_SET_DA1_LOW  0x6                          /* Load low byte + output to channel DA-1 */
#define M029_POWER_DOWN1  0x7                          /* Power down                             */


#define WAITTIME          5		/* Delay min. 5 microseconds */

#if defined(__cplusplus)
extern "C" {
#endif

/* Init module library
*/
MLXAPI void EXPORT m029_bib_startup (void);

/* Init module like definitions in EEPROM
*/
MLXAPI void EXPORT m029_set_conf_eeprom (byte micro_slot);

/* Define correction values
*/
MLXAPI void EXPORT m029_set_correct_values (byte micro_slot, byte channel, short corgain, short coroffset);

/* Read correction values
*/
MLXAPI void EXPORT m029_get_correct_values (byte micro_slot, byte channel, short *corgain, short *coroffset);

/* Correct output value
*/
MLXAPI void EXPORT m029_correct (byte micro_slot, byte channel, short *data_var);

/* Output voltage to D/A-channel
*/
MLXAPI void EXPORT m029_out (byte micro_slot, byte channel, byte flag, short data_var);

/* Read set value of D/A-channel
*/
MLXAPI void EXPORT m029_get_setvalue (byte micro_slot, byte channel, short *datbyte);

#if defined(__cplusplus)
} /*  End of block of extern "C" */
#endif

#endif