{$C MOVEABLE DEMANDLOAD DISCARDABLE}
(***************************************************************************)
(**                                                                       **)
(**              MODULAR-4 library for SPB module M-DA16-2                 **)
(**                                                                       **)
(**  This file contains routines for Borland Pascal to allow the user,    **)
(**  to write programs for the MODULAR-4 in "Pascal" 			  **)
(**                                                                       **)
(**                             Version 2.E.                              **)
(**                                                                       **)
(**                    Last change : 28.11.1996                           **)
(**                    Adaptation to Windows 95, Windows NT and OS/2      **)
(**                                                                       **)
(**                             Version 2.D.                              **)
(**                                                                       **)
(**  This file contains routines for Borland Pascal to allow the user,    **)
(**  to write programs for the MODULAR-4 in "Pascal" 			  **)
(**                                                                       **)
(**                    Last change : 07.07.1995 2.D.                      **)
(**                                                                       **)
(**     Changes between version 2.C and 2.D.:                             **)
(**     - changes only in C-source                                        **)
(**                                                                       **)
(**                    Last change : 17.05.1995 2.C.                      **)
(**                                                                       **)
(**                    Last change : 14.10.1994 2.B.                      **)
(**                                                                       **)
(**                Date of release : 04.02.1994 2.A.                      **)
(**                         Author : H.K.                                 **)
(**                         Status : O.K.                                 **)
(**                                                                       **)
(**                                                                       **)
(** Special comments: 							  **)
(**                                                                       **)
(** This library was tested with Borland Pascal Version 7.0.	          **)
(**                                                                       **)
(** No parameters are checked.						  **)
(**                                                                       **)
(**                                                                       **)
(**                                                                       **)
(**               (c) SORCUS Computer GmbH 1995                           **)
(**                                                                       **)
(***************************************************************************)

(* The switches for the library are set in the configuration files of Pascal
   (*.TP file) and C (project-file). They can also be set in this source file:

   Then the following #defines have to exist:

   If you use Pascal, #define BORLAND_PASCAL has to be included (default is C).

   If the library shall be used as realtime library on the MODULAR-4/486
   #define ML8 and #define ML8RT have to be included (default is PC library).

   If you work with Windows, this is detected by the compiler. No #defines have
   to be included.
*)

unit m029_lib;
interface
uses
{$IFDEF ML8}
        {$IFDEF Windows}
                wml8bib;        (* Include library for MODULAR-4/486 under Windows *)
        {$ELSE}
               {$IFDEF ML8RT}
                       ml8rtbib;    (* Include library for MODULAR-4/486 realtime programs *)
               {$ELSE}
                       ml8bib;      (* Include library for MODULAR-4/486 under DOS *)
               {$ENDIF}
        {$ENDIF}
{$ELSE}
        {$IFDEF Windows}
                wml4bib,wml4deb;    (* Include library for MODULAR-4/Z80 under WINDOWS *)
        {$ELSE}
                ml4bib,ml4deb;      (* Include library for MODULAR-4/Z80 under DOS *)
        {$ENDIF}
{$ENDIF}

{$IFDEF Windows}
const
     M029DLL = 'M029_LIB';
{$ENDIF}

(* Init modul library *)

procedure m029_bib_startup;

(* Init module like definitions in EEPROM *)

procedure m029_set_conf_eeprom(micro_slot: byte);

(* Define correction values *)

procedure m029_set_correct_values(micro_slot: byte; channel:byte; corgain, coroffset:integer);

(* Read correction values *)

procedure m029_get_correct_values(micro_slot: byte; channel:byte; var corgain, coroffset:integer);

(* Correct output value *)

procedure m029_correct (micro_slot: byte; channel: byte; var data_var: integer);

(* Output value to D/A-channel *)

procedure m029_out(micro_slot: byte; channel: byte; flag: byte; datbyte: integer);

(* Read set value of D/A-channel *)

procedure m029_get_setvalue (micro_slot: byte;channel: byte; var datbyte: integer);


implementation

{$IFNDEF Windows}   (* If no DLL is used, a .OBJ file has to be included *)

{$L m029_lib.obj}

{$ENDIF}


(* Init module library *)

procedure m029_bib_startup;
          external {$IFDEF Windows} M029DLL {$ENDIF};

(* Definr correction values *)

procedure m029_set_correct_values(micro_slot: byte; channel:byte; corgain, coroffset:integer);
          external {$IFDEF Windows} M029DLL {$ENDIF};

(* Read correction values *)

procedure m029_get_correct_values(micro_slot: byte; channel:byte; var corgain, coroffset:integer);
          external {$IFDEF Windows} M029DLL {$ENDIF};

(* Init module like definitions in EEPROM *)

procedure m029_set_conf_eeprom(micro_slot: byte);
          external {$IFDEF Windows} M029DLL {$ENDIF};

(* Correct output value *)

procedure m029_correct (micro_slot: byte; channel: byte; var data_var: integer);
          external {$IFDEF Windows} M029DLL {$ENDIF};

(* Output value to D/A-channel *)

procedure m029_out(micro_slot: byte; channel: byte; flag: byte; datbyte: integer);
          external {$IFDEF Windows} M029DLL {$ENDIF};

(* Read set value of D/A-channel *)

procedure m029_get_setvalue (micro_slot: byte;channel: byte; var datbyte: integer);
          external {$IFDEF Windows} M029DLL {$ENDIF};


begin
end.